package com.baofoo.demo;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.Enumeration;

import javax.servlet.ServletException;
import javax.servlet.annotation.WebServlet;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import com.baofoo.rsa.RsaCodingUtil;
import com.baofoo.util.GepUtils;
import com.baofoo.util.SecurityUtil;


/**
 * Servlet implementation class NotifyServlet
 * 1、vcc的webhook通知，通知地址需线下申请配置
 * 2、其他异步通知处理
 * 注：
 * ①、异步通知需要返回OK(vcc的webhook通知需响应200)
 * ②、异步通知间隔依次递增，最大通知10次，如返回OK则不继续通知(vcc的webhook通知响应200后不再通知)
 * ③、通知间隔(分钟)：0、1、3、6、10、15、21、28、36、45
 */
@WebServlet("/Notify/*")
public class NotifyServlet extends HttpServlet {
	private static final long serialVersionUID = 1L;
       
    /**
     * @see HttpServlet#HttpServlet()
     */
    public NotifyServlet() {
        super();
        // TODO Auto-generated constructor stub
    }

	/**
	 * @see HttpServlet#doGet(HttpServletRequest request, HttpServletResponse response)
	 */
	protected void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		// TODO Auto-generated method stub
		//response.getWriter().append("Served at: ").append(request.getContextPath());
		doPost(request, response);
	}

	/**
	 * @see HttpServlet#doPost(HttpServletRequest request, HttpServletResponse response)
	 */
	protected void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		// TODO Auto-generated method stub
		GepUtils.log("--------------------------------接收到异步回调，开始处理----------------------------------");
		String path = request.getPathInfo(); // 获取路径
		 if (path != null && path.contains("webhook")) {// 如果vcc通知地址有"webhook"则可以使用此方法判断，没有则需商户自行判断
			 BufferedReader reader = new BufferedReader(new InputStreamReader(request.getInputStream()));
				StringBuilder builder = new StringBuilder();
				String line;
				while ((line = reader.readLine()) != null) {
					builder.append(line);
				}
				String data = builder.toString();
				GepUtils.log("接收到webhook通知内容: " + data);

				if (!"".equals(data)) {
					String resultObjectStr = RsaCodingUtil.decryptByPubCerFile(data, GepUtils.cerpath);
					resultObjectStr = SecurityUtil.Base64Decode(resultObjectStr);
					GepUtils.log("webhook解密后：" + resultObjectStr);//格式示例{"type":"type_card_operate","data":{}}
					// TODO 业务处理
				}
		 }else {
			 Enumeration<?> enu = request.getParameterNames();
		        while (enu.hasMoreElements()) {
		            String paraName = (String) enu.nextElement();
		            GepUtils.log("接收通知参数：" + paraName + ": " + request.getParameter(paraName));
		        }
		        String dataContent = request.getParameter("dataContent");
		        if (dataContent != null) {
		            dataContent = RsaCodingUtil.decryptByPubCerFile(dataContent, GepUtils.cerpath);
		            dataContent = SecurityUtil.Base64Decode(dataContent);;
		            GepUtils.log("密文 dataContent 解密后：" + dataContent);
		            // TODO 业务处理
		        }
		 }
		
		GepUtils.log("--------------------------------接收到异步回调，处理结束----------------------------------");
		response.setContentType("text/html;charset=utf-8");
		PrintWriter pw = response.getWriter();
		pw.write("OK");// 收到通知需返回OK
	}

}
